﻿using System.Text;
using UnityEngine;

namespace FL.Editor.Tests
{
    public class TestDigits
    {
        [UnityEditor.MenuItem("Test/Digits/Encrypt")]
        public static void Encrypt()
        {
            var digit = "120";
            uint r = 100;// 1000000000;
            uint i = 46;// 534862510;
            var bytes = Encoding.UTF8.GetBytes(digit);
            var result = EncryptXor(bytes, i, r);
            //EncryptXor(new byte[] { 1, 2, 0 }, 10);
            var test1 = 0b100011 ^ 0b10;
            var test2 = 0b110010 ^ 0b10;
            Debug.Log($"Encrypt value:{digit} Result:{result} test1:{test1} test2:{test2}");
        }
        public static void EncryptXor(byte[] bytes, uint key)
        {
            if (bytes == null)
                return;
            for (var i = 0; i < bytes.Length; i++) // 依次对字符串中各字符进行操作
            {
                var current = bytes[i];
                bytes[i] = (byte)(current ^ key); // 将密钥与字符异或
            }
        }
        /// <summary>
        /// 异或加密
        /// </summary>
        /// <param name="bytes"></param>
        /// <param name="i">默认为 1023</param>
        private static long EncryptXor(byte[] bytes, uint i, uint r)
        {
            if (bytes == null)
                return 0;
            if (bytes.Length == 1)
            {
                return bytes[0] ^ i;
            }
            long n = (bytes[0] ^ i);

            for (long t = r, s = 1; s < bytes.Length; s++)
            {
                long e = (bytes[s] ^ i) * t;
                n = n + e;
                t = t * r;
            }
            return n;
        }
        [UnityEditor.MenuItem("Test/Digits/Float")]
        private static void TestFloat()
        {
            var val = 1833.33333333f;
            Debug.Log($"Round:{Mathf.RoundToInt(val)} Ceil:{Mathf.CeilToInt(val)}  Float:{Mathf.FloorToInt(val)}");
        }
    }
}
