using System.Collections;
using System.Collections.Generic;
using System.IO;
using UnityEditor;
using UnityEngine;
using XGame.Editor.Asset;
using XGame.Framework.Json;

namespace FL.Editor
{
    public class TestJson
    {
        [MenuItem("Test/Json/ToBytes")]
        private static void ToTables()
        {
            var task = new TestJson();
            task.Start();

        }
        private void Start()
        {
            var jsonFolder = PathDefine.ExtAssetsPath + "/Editor/json";
            if (!Directory.Exists(jsonFolder))
            {
                return;
            }
            var tableFolder = PathDefine.ExtAssetsPath + "/Editor/Tables";
            if (Directory.Exists(tableFolder))
            {
                Directory.Delete(tableFolder, true);
            }
            Directory.CreateDirectory(tableFolder);
            var templeTable = File.ReadAllText(PathDefine.ExtAssetsPath + "/Editor/TemplateTable.cs");
            var jsonPaths = Directory.GetFiles(jsonFolder, "*.json", SearchOption.AllDirectories);
            foreach (var jsonPath in jsonPaths)
            {
                var fileName = Path.GetFileNameWithoutExtension(jsonPath);
                var text = File.ReadAllText(jsonPath);
                var objArray = XJson.ToObject(text);
                var obj = objArray.IsArray ? objArray[0] : objArray;
                var keys = obj.Keys;
                if (keys.Count == 0)
                {
                    continue;
                }

                foreach (var key in keys)
                {
                    var value = obj[key];
                    if (value == null)
                        continue;
                    if (value.IsString)
                    {

                    }
                    else if (value.IsDouble)
                    {

                    }
                    else if (value.IsInt)
                    {
                        Debug.Log($"int Key:{key} value:{value}");
                    }
                    else if (value.IsLong)
                    {
                        Debug.Log($"long Key:{key} value:{value}");
                    }
                    else if (value.IsBoolean)
                    {
                        Debug.Log($"bool Key:{key} value:{value}");
                    }
                }
            }
        }
    }
}
