using Spine;
using Spine.Unity;
using UnityEditor;
using UnityEngine;

namespace FL.Editor.Tests
{
    public class TestSpine
    {
        [MenuItem("Test/Spine/TestType")]
        public static void TestType()
        {
            var type = typeof(SkeletonDataAsset);
            Debug.Log($"Type FullName:{type.FullName} Namespace:{type.Namespace} Name:{type.Name}");
        }
        [MenuItem("Test/Spine/EventTime")]
        public static void TestEventTime()
        {
            var impl = new TestSpine();
            impl.Start();
        }
        public void Start()
        {
            var guids = AssetDatabase.FindAssets("t:SkeletonDataAsset");
            foreach (var guid in guids)
            {
                var assetPath = AssetDatabase.GUIDToAssetPath(guid);
                Debug.Log($"SkeletonDataAsset Path:{assetPath}");
                var asset = AssetDatabase.LoadAssetAtPath<SkeletonDataAsset>(assetPath);
                TestEventTime(asset);
            }
        }
        //TODO spine¼
        private void TestEventTime(SkeletonDataAsset skeletonDataAsset)
        {
            var skData = skeletonDataAsset.GetSkeletonData(false);
            foreach (var animation in skData.Animations) 
            {
                foreach (var timeline in animation.Timelines)
                {
                    if (timeline is EventTimeline eventTimeline)
                    {
                        foreach (var @event in eventTimeline.Events)
                        {
                            Debug.Log($"Asset:{skeletonDataAsset.name} Animation:{animation.Name} Duration:{animation.Duration} Event:{@event.Data.Name} Time:{@event.Time}");
                        }
                    }
                }
            }
            
        }

    }
}
